import "Hardcore.Hardcore"

-- Set functions
AddCallback = PrimeUtils.Utils.AddCallback
RemoveCallback = PrimeUtils.Utils.RemoveCallback
ChatOutput = PrimeUtils.Utils.Print
PrintTable = PrimeUtils.Utils.PrintTable

-- Set handlers
Updater = PrimeUtils.Utils.Handlers.UpdateHandler()
ActionHandler = PrimeUtils.Utils.Handlers.ActionHandler()
ChatEventHandler = PrimeUtils.Utils.Handlers.ChatHandler()
--GroupEffectsHandler = PrimeUtils.Utils.Handlers.GroupEffectEvents()
LocationHandler = PrimeUtils.Utils.Handlers.LocationHandler()
PlayerEffectsHandler = PrimeUtils.Utils.Handlers.PlayerEffectEvents()
PlayerHandler = PrimeUtils.Utils.Handlers.PlayerHandler()
SkillEventHandler = PrimeUtils.Utils.Handlers.PlayerSkillEvents()
TargetHandler = PrimeUtils.Utils.Handlers.TargetEventHandling()
InstanceController = PrimeUtils.Utils.Handlers.InstanceHub()
AchievementsPanel = PrimeUtils.Utils.AchievementListBox()
HardcoreHandler = HardcoreHandler()


Reloader = class(Turbine.UI.Control)
function Reloader:Constructor()
    Turbine.UI.Control.Constructor(self)
    self:SetWantsUpdates(true)
    self.reloaded = false
    self.Update = function()
        if self.reloaded then
            self:SetWantsUpdates(false)    
        elseif not(self.reloaded) then 
            Turbine.PluginManager.UnloadScriptState("~HardcoreReloader")
            self.reloaded = true
            self:SetParent(nil)
        end
    end
end
local r = Reloader()

-- Set the unload events
plugin.Unload = function() 
    HardcoreHandler:Unload()
end

function ReloadPlugin()
    Turbine.PluginManager.LoadPlugin("~HardcoreReloader")
end